import * as i0 from '@angular/core';
import { forwardRef, Component, Input, HostListener, NgModule } from '@angular/core';
import * as i6 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i1 from '@angular/cdk/overlay';
import { OverlayModule } from '@angular/cdk/overlay';
import * as i2 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i3 from '@angular/material/form-field';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i7 from '@iplab/ngx-color-picker';
import { ColorPickerModule } from '@iplab/ngx-color-picker';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

class NgxMatColorPickerComponent {
    constructor() {
        this.positionPairs = [
            {
                originX: 'start',
                originY: 'bottom',
                overlayX: 'start',
                overlayY: 'bottom',
                offsetX: -210,
                offsetY: 0,
            },
        ];
        this.chosenColor = '#FFFFFF';
        this.pickerVisible = false;
        this.onChange = () => { };
        this.onTouched = () => { };
    }
    ngOnInit() {
        this.formSubscription = this.form
            .get(this.formControlName)
            ?.valueChanges.subscribe((value) => {
            if (this.validColor(value)) {
                this.chosenColor = value.toUpperCase();
            }
        });
    }
    ngOnDestroy() {
        if (this.formSubscription)
            this.formSubscription.unsubscribe();
    }
    writeValue(color) {
        this.chosenColor = color;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    changeFormColor($event) {
        this.form.get(this.formControlName)?.setValue($event.toUpperCase());
    }
    onEscape($event) {
        $event.preventDefault();
        this.pickerVisible = false;
    }
    onEnter($event) {
        $event.preventDefault();
    }
    validColor(color) {
        return /^#[0-9a-fA-F]{6}$/i.test(color);
    }
}
NgxMatColorPickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgxMatColorPickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.8", type: NgxMatColorPickerComponent, selector: "ngx-mat-color-picker", inputs: { appearance: "appearance", color: "color", label: "label", placeholder: "placeholder", formControlName: "formControlName", form: "form" }, host: { listeners: { "document:keydown.escape": "onEscape($event)", "document:keydown.enter": "onEnter($event)" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NgxMatColorPickerComponent),
            multi: true,
        },
    ], ngImport: i0, template: "<mat-form-field [appearance]=appearance [color]=color>\r\n    <mat-label>{{ label }}</mat-label>\r\n    <div class=\"mat-form-group\" [formGroup]=\"form\">\r\n        <input matInput ngDefaultControl [formControlName]=formControlName [placeholder]=placeholder>\r\n        <button mat-icon-button (click)=\"pickerVisible = !pickerVisible\" cdkOverlayOrigin #trigger=\"cdkOverlayOrigin\">\r\n            <mat-icon>palette</mat-icon>\r\n        </button>\r\n    </div>\r\n</mat-form-field>\r\n<ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=pickerVisible [cdkConnectedOverlayHasBackdrop]=pickerVisible [cdkConnectedOverlayPositions]=positionPairs (backdropClick)=\"pickerVisible = !pickerVisible\">\r\n    <chrome-picker [color]=\"chosenColor\" (colorChange)=\"changeFormColor($event)\" style.display=\"{{pickerVisible ? 'block' : 'none'}}\"></chrome-picker>\r\n</ng-template>\r\n", styles: ["mat-form-field{width:100%}mat-form-field .mat-form-group{display:flex;align-items:center;height:18px}mat-form-field .mat-form-group button{top:-.25rem}chrome-picker{position:absolute}\n"], dependencies: [{ kind: "directive", type: i1.CdkConnectedOverlay, selector: "[cdk-connected-overlay], [connected-overlay], [cdkConnectedOverlay]", inputs: ["cdkConnectedOverlayOrigin", "cdkConnectedOverlayPositions", "cdkConnectedOverlayPositionStrategy", "cdkConnectedOverlayOffsetX", "cdkConnectedOverlayOffsetY", "cdkConnectedOverlayWidth", "cdkConnectedOverlayHeight", "cdkConnectedOverlayMinWidth", "cdkConnectedOverlayMinHeight", "cdkConnectedOverlayBackdropClass", "cdkConnectedOverlayPanelClass", "cdkConnectedOverlayViewportMargin", "cdkConnectedOverlayScrollStrategy", "cdkConnectedOverlayOpen", "cdkConnectedOverlayDisableClose", "cdkConnectedOverlayTransformOriginOn", "cdkConnectedOverlayHasBackdrop", "cdkConnectedOverlayLockPosition", "cdkConnectedOverlayFlexibleDimensions", "cdkConnectedOverlayGrowAfterOpen", "cdkConnectedOverlayPush"], outputs: ["backdropClick", "positionChange", "attach", "detach", "overlayKeydown", "overlayOutsideClick"], exportAs: ["cdkConnectedOverlay"] }, { kind: "directive", type: i1.CdkOverlayOrigin, selector: "[cdk-overlay-origin], [overlay-origin], [cdkOverlayOrigin]", exportAs: ["cdkOverlayOrigin"] }, { kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "component", type: i3.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i6.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i6.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i6.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i6.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i6.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: i7.ChromePickerComponent, selector: "chrome-picker", inputs: ["color", "control"], outputs: ["colorChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-mat-color-picker', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NgxMatColorPickerComponent),
                            multi: true,
                        },
                    ], template: "<mat-form-field [appearance]=appearance [color]=color>\r\n    <mat-label>{{ label }}</mat-label>\r\n    <div class=\"mat-form-group\" [formGroup]=\"form\">\r\n        <input matInput ngDefaultControl [formControlName]=formControlName [placeholder]=placeholder>\r\n        <button mat-icon-button (click)=\"pickerVisible = !pickerVisible\" cdkOverlayOrigin #trigger=\"cdkOverlayOrigin\">\r\n            <mat-icon>palette</mat-icon>\r\n        </button>\r\n    </div>\r\n</mat-form-field>\r\n<ng-template cdkConnectedOverlay [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=pickerVisible [cdkConnectedOverlayHasBackdrop]=pickerVisible [cdkConnectedOverlayPositions]=positionPairs (backdropClick)=\"pickerVisible = !pickerVisible\">\r\n    <chrome-picker [color]=\"chosenColor\" (colorChange)=\"changeFormColor($event)\" style.display=\"{{pickerVisible ? 'block' : 'none'}}\"></chrome-picker>\r\n</ng-template>\r\n", styles: ["mat-form-field{width:100%}mat-form-field .mat-form-group{display:flex;align-items:center;height:18px}mat-form-field .mat-form-group button{top:-.25rem}chrome-picker{position:absolute}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { appearance: [{
                type: Input
            }], color: [{
                type: Input
            }], label: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], formControlName: [{
                type: Input
            }], form: [{
                type: Input
            }], onEscape: [{
                type: HostListener,
                args: ['document:keydown.escape', ['$event']]
            }], onEnter: [{
                type: HostListener,
                args: ['document:keydown.enter', ['$event']]
            }] } });

class NgxMatColorPickerModule {
}
NgxMatColorPickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxMatColorPickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerModule, declarations: [NgxMatColorPickerComponent], imports: [OverlayModule,
        MatIconModule,
        MatInputModule,
        MatButtonModule,
        BrowserAnimationsModule,
        FormsModule,
        ReactiveFormsModule,
        ColorPickerModule], exports: [NgxMatColorPickerComponent] });
NgxMatColorPickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerModule, imports: [OverlayModule,
        MatIconModule,
        MatInputModule,
        MatButtonModule,
        BrowserAnimationsModule,
        FormsModule,
        ReactiveFormsModule,
        ColorPickerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: NgxMatColorPickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgxMatColorPickerComponent],
                    imports: [
                        OverlayModule,
                        MatIconModule,
                        MatInputModule,
                        MatButtonModule,
                        BrowserAnimationsModule,
                        FormsModule,
                        ReactiveFormsModule,
                        ColorPickerModule,
                    ],
                    exports: [NgxMatColorPickerComponent],
                }]
        }] });

/*
 * Public API Surface of ngx-mat-color-picker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxMatColorPickerComponent, NgxMatColorPickerModule };
//# sourceMappingURL=ngx-mat-color-picker.mjs.map
